/* bbin.c
 *
 * Linguagem C - rvores Binrias
 * Viva O Linux
 *
 * Enzo Ferber : enzoferber@gmail.com
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

int bbin (int *a, int min, int max, int info)
{
	int pos = (min + max) / 2;

	if (a[pos] == info) return pos;
	else if (min >= max) return -1;
	else if (info > a[pos]) return bbin(a, pos + 1, max, info);
	else return bbin(a, min, pos - 1, info);

	return -1;
}

int main (void)
{
	int a[10] = {1,2,3,4,5,6,7,8,9,10};

	printf("1: %d\n", bbin(a, 0, 10, 1));
	printf("5: %d\n", bbin(a, 0, 10, 5));
	printf("8: %d\n", bbin(a, 0, 10, 8));
	printf("0: %d\n", bbin(a, 0, 10, 0));
	printf("9: %d\n", bbin(a, 0, 10, 9));

	return 0;
}

